﻿Public Class Form1
    ' Draw the appropriate graph.
    Private Sub radF1_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles radF1.Click
        DrawGraph(AddressOf F1)
    End Sub

    Private Sub radF2_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles radF2.Click
        DrawGraph(AddressOf F2)
    End Sub

    Private Sub radF3_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles radF3.Click
        DrawGraph(AddressOf F3)
    End Sub

    Private Sub radF4_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles radF4.Click
        DrawGraph(AddressOf F4)
    End Sub

    ' Define a delegate type named FofXY.
    Private Delegate Function FofXY(ByVal x As Single, ByVal y As Single) As Single

    ' Draw the indicated function.
    Private Sub DrawGraph(ByVal func As FofXY)
        Me.Cursor = Cursors.WaitCursor

        ' Make the Bitmap.
        Dim bm As New Bitmap(picGraph.ClientSize.Width, picGraph.ClientSize.Height)
        Using gr As Graphics = Graphics.FromImage(bm)
            ' Clear.
            gr.Clear(Color.White)
            gr.ScaleTransform(15.0F, -15.0F, System.Drawing.Drawing2D.MatrixOrder.Append)
            gr.TranslateTransform(bm.Width * 0.5F, bm.Height * 0.5F, _
                System.Drawing.Drawing2D.MatrixOrder.Append)

            ' Draw axes.
            Using axis_pen As New Pen(Color.LightGray, 0)
                gr.DrawLine(axis_pen, -8, 0, 8, 0)
                gr.DrawLine(axis_pen, 0, -8, 0, 8)
                For i As Integer = -8 To 8
                    gr.DrawLine(axis_pen, i, -0.1F, i, 0.1F)
                    gr.DrawLine(axis_pen, -0.1F, i, 0.1F, i)
                Next i
            End Using

            ' Graph the equation.
            Dim dx As Single = 2.0F / bm.Width
            Dim dy As Single = 2.0F / bm.Height
            PlotFunction(gr, func, -8, -8, 8, 8, dx, dy)
        End Using

        ' Display the result.
        picGraph.Image = bm
        Me.Cursor = Cursors.Default
    End Sub

    ' Plot a function.
    Private Sub PlotFunction(ByVal gr As Graphics, ByVal func As FofXY, _
     ByVal xmin As Single, ByVal ymin As Single, ByVal xmax As Single, ByVal ymax As Single, _
     ByVal dx As Single, ByVal dy As Single)
        ' Plot the function.
        Using thin_pen As New Pen(Color.Black, 0)
            ' Horizontal comparisons.
            For x As Single = xmin To xmax Step dx
                Dim last_y As Single = func(x, ymin)
                For y As Single = ymin + dy To ymax Step dy
                    Dim next_y As Single = func(x, y)
                    If ( _
                        ((last_y <= 0.0F) AndAlso (next_y >= 0.0F)) OrElse _
                        ((last_y >= 0.0F) AndAlso (next_y <= 0.0F)) _
                       ) _
                   Then
                        ' Plot this point.
                        gr.DrawLine(thin_pen, x, y - dy, x, y)
                    End If
                    last_y = next_y
                Next y
            Next x ' Horizontal comparisons.

            ' Vertical comparisons.
            For y As Single = ymin + dy To ymax Step dy
                Dim last_x As Single = func(xmin, y)
                For x As Single = xmin + dx To xmax Step dx
                    Dim next_x As Single = func(x, y)
                    If ( _
                        ((last_x <= 0.0F) AndAlso (next_x >= 0.0F)) OrElse _
                        ((last_x >= 0.0F) AndAlso (next_x <= 0.0F)) _
                       ) _
                    Then
                        ' Plot this point.
                        gr.DrawLine(thin_pen, x - dx, y, x, y)
                    End If
                    last_x = next_x
                Next x
            Next y ' Vertical comparisons.
        End Using
    End Sub

    ' The functions.
    ' x^2 + x*y - y = 0
    Private Function F1(ByVal x As Single, ByVal y As Single) As Single
        Return (x * x + x * y - y)
    End Function

    ' y - 1 / x^2 = 0
    Private Function F2(ByVal x As Single, ByVal y As Single) As Single
        Return (y - 1 / (x * x))
    End Function

    ' x^2 + (2 * y)^2 - 49 = 0
    Private Function F3(ByVal x As Single, ByVal y As Single) As Single
        Return (x * x + (2 * y) * (2 * y) - 49)
    End Function

    ' y - 3 * Cos(x) / x
    Private Function F4(ByVal x As Single, ByVal y As Single) As Single
        Return CSng(y - 3 * Math.Cos(x) / x)
    End Function
End Class
